Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/advtrac_loc.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/advtrac_loc.f90	(revision 5101)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/advtrac_loc.f90	(revision 5101)
@@ -0,0 +1,288 @@
+SUBROUTINE advtrac_loc(pbarug, pbarvg, wg, p, massem, q, teta, pk)
+  !     Auteur :  F. Hourdin
+
+  !     Modif. P. Le Van     (20/12/97)
+  !            F. Codron     (10/99)
+  !            D. Le Croller (07/2001)
+  !            M.A Filiberti (04/2002)
+
+  USE infotrac, ONLY: nqtot, tracers
+  USE control_mod, ONLY: iapp_tracvl, day_step, planet_type
+  USE comconst_mod, ONLY: dtvr
+  USE parallel_lmdz
+  USE Write_Field_loc
+  USE Write_Field
+  USE Bands
+  USE mod_hallo
+  USE Vampir
+  USE times
+  USE advtrac_mod, ONLY: finmasse
+  USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_DEBUGIO
+
+  IMPLICIT NONE
+
+  include "dimensions.h"
+  include "paramet.h"
+  include "comdissip.h"
+  include "comgeom2.h"
+  include "description.h"
+  !   include "iniprint.h"
+
+  !---------------------------------------------------------------------------
+  !     Arguments
+  !---------------------------------------------------------------------------
+  REAL, INTENT(IN) :: pbarug(ijb_u:ije_u, llm)
+  REAL, INTENT(IN) :: pbarvg(ijb_v:ije_v, llm)
+  REAL, INTENT(IN) :: wg(ijb_u:ije_u, llm)
+  REAL, INTENT(IN) :: p(ijb_u:ije_u, llmp1)
+  REAL, INTENT(IN) :: massem(ijb_u:ije_u, llm)
+  REAL, INTENT(INOUT) :: q(ijb_u:ije_u, llm, nqtot)
+  REAL, INTENT(IN) :: teta(ijb_u:ije_u, llm)
+  REAL, INTENT(IN) :: pk(ijb_u:ije_u, llm)
+  !---------------------------------------------------------------------------
+  !     Ajout PPM
+  !---------------------------------------------------------------------------
+  REAL :: massebx(ijb_u:ije_u, llm), masseby(ijb_v:ije_v, llm)
+  !---------------------------------------------------------------------------
+  !     Variables locales
+  !---------------------------------------------------------------------------
+  INTEGER :: ij, l, iq, iadv
+  REAL(KIND = KIND(1.d0)) :: t_initial, t_final, tps_cpu
+  REAL :: zdp(ijb_u:ije_u), zdpmin, zdpmax
+  INTEGER, SAVE :: iadvtr = 0
+  !$OMP THREADPRIVATE(iadvtr)
+  EXTERNAL  minmax
+
+  !---------------------------------------------------------------------------
+  !     Rajouts pour PPM
+  !---------------------------------------------------------------------------
+  INTEGER :: indice, n
+  REAL :: dtbon                       ! Pas de temps adaptatif pour que CFL<1
+  REAL :: CFLmaxz, aaa, bbb           ! CFL maximum
+  REAL, DIMENSION(iim, jjb_u:jje_u, llm) :: unatppm, vnatppm, fluxwppm
+  REAL :: qppm(iim * jjnb_u, llm, nqtot)
+  REAL :: psppm(iim, jjb_u:jje_u)    ! pression  au sol
+  REAL, DIMENSION(llmp1) :: apppm, bpppm
+  LOGICAL, SAVE :: dum = .TRUE., fill = .TRUE.
+  INTEGER :: ijb, ije, ijbu, ijbv, ijeu, ijev, j
+  TYPE(Request), SAVE :: testRequest
+  !$OMP THREADPRIVATE(testRequest)
+
+  ! Test sur l'eventuelle creation de valeurs negatives de la masse
+  ijb = ij_begin; IF(pole_nord) ijb = ij_begin + iip1
+  ije = ij_end;   IF(pole_sud)  ije = ij_end - iip1
+
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l = 1, llm - 1
+    DO ij = ijb + 1, ije
+      zdp(ij) = pbarug(ij - 1, l) - pbarug(ij, l) &
+              - pbarvg(ij - iip1, l) + pbarvg(ij, l) &
+              + wg(ij, l + 1) - wg(ij, l)
+    END DO
+    ! ym  ---> pourquoi jjm-1 et non jjm ? a cause du pole ?
+    !     CALL SCOPY( jjm -1 ,zdp(iip1+iip1),iip1,zdp(iip2),iip1 )
+    DO ij = ijb, ije - iip1 + 1, iip1
+      zdp(ij) = zdp(ij + iip1 - 1)
+    END DO
+    DO ij = ijb, ije
+      zdp(ij) = zdp(ij) * dtvr / massem(ij, l)
+    END DO
+    !     CALL minmax ( ip1jm-iip1, zdp(iip2), zdpmin,zdpmax )
+    ! ym ---> eventuellement a revoir
+    CALL minmax(ije - ijb + 1, zdp(ijb), zdpmin, zdpmax)
+    IF(MAX(ABS(zdpmin), ABS(zdpmax)) >0.5) &
+            WRITE(*, *)'WARNING DP/P l=', l, '  MIN:', zdpmin, '   MAX:', zdpmax
+  END DO
+  !$OMP END DO NOWAIT
+
+  !---------------------------------------------------------------------------
+  !   Advection proprement dite (Modification Le Croller (07/2001)
+  !---------------------------------------------------------------------------
+
+  !---------------------------------------------------------------------------
+  !   Calcul des moyennes basees sur la masse
+  !---------------------------------------------------------------------------
+  !ym   CALL massbar_p(massem,massebx,masseby)
+  !ym   ----> Normalement, inutile pour les schemas classiques
+  !ym   ----> Reverifier lors de la parallelisation des autres schemas
+
+  IF (CPPKEY_DEBUGIO) THEN
+    CALL WriteField_u('massem', massem)
+    CALL WriteField_u('wg', wg)
+    CALL WriteField_u('pbarug', pbarug)
+    CALL WriteField_v('pbarvg', pbarvg)
+    CALL WriteField_u('p_tmp', p)
+    CALL WriteField_u('pk_tmp', pk)
+    CALL WriteField_u('teta_tmp', teta)
+    DO iq = 1, nqtot
+      CALL WriteField_u('q_adv' // trim(int2str(iq)), q(:, :, iq))
+    END DO
+  END IF
+
+  !  CALL Register_Hallo_v(pbarvg,llm,1,1,1,1,TestRequest)
+  !  CALL SendRequest(TestRequest)
+  !!$OMP BARRIER
+  !  CALL WaitRequest(TestRequest)
+  !$OMP BARRIER
+
+  !  WRITE(*,*) 'advtrac 157: appel de vlspltgen_loc'
+  CALL vlspltgen_loc(q, 2., massem, wg, pbarug, pbarvg, dtvr, p, pk, teta)
+
+  IF (CPPKEY_DEBUGIO) THEN
+    DO iq = 1, nqtot
+      CALL WriteField_u('q_adv' // trim(int2str(iq)), q(:, :, iq))
+    END DO
+  END IF
+
+  GOTO 1234
+  !-------------------------------------------------------------------------
+  !       Appel des sous programmes d'advection
+  !-------------------------------------------------------------------------
+  DO iq = 1, nqtot
+    !     CALL clock(t_initial)
+    IF(tracers(iq)%parent /= 'air') CYCLE
+    iadv = tracers(iq)%iadv
+    !-----------------------------------------------------------------------
+    SELECT CASE(iadv)
+      !-----------------------------------------------------------------------
+    CASE(0); CYCLE
+    !--------------------------------------------------------------------
+    CASE(10)  !--- Schema de Van Leer I MUSCL
+      !--------------------------------------------------------------------
+      !           WRITE(*,*) 'advtrac 239: iq,q(1721,19,:)=',iq,q(1721,19,:)
+      !LF         CALL vlsplt_p(q(1,1,iq),2.,massem,wg,pbarug,pbarvg,dtvr)
+
+      !--------------------------------------------------------------------
+    CASE(14)  !--- Schema "pseuDO amont" + test sur humidite specifique
+      !--- pour la vapeur d'eau. F. Codron
+      !--------------------------------------------------------------------
+      !           WRITE(*,*) 'advtrac 248: iq,q(1721,19,:)=',iq,q(1721,19,:)
+      CALL abort_gcm("advtrac", "appel a vlspltqs :schema non parallelise", 1)
+      !LF         CALL vlspltqs_p(q(1,1,1),2.,massem,wg,pbarug,pbarvg,dtvr,p,pk,teta )
+
+      !--------------------------------------------------------------------
+    CASE(12)  !--- Schema de Frederic Hourdin
+      !--------------------------------------------------------------------
+      CALL abort_gcm("advtrac", "appel a vlspltqs :schema non parallelise", 1)
+      CALL adaptdt(iadv, dtbon, n, pbarug, massem)   ! pas de temps adaptatif
+      IF(n > 1) WRITE(*, *) 'WARNING horizontal dt=', dtbon, 'dtvr=', dtvr, 'n=', n
+      DO indice = 1, n
+        CALL advn(q(1, 1, iq), massem, wg, pbarug, pbarvg, dtbon, 1)
+      END DO
+
+      !--------------------------------------------------------------------
+    CASE(13)  !--- Pas de temps adaptatif
+      !--------------------------------------------------------------------
+      CALL abort_gcm("advtrac", "schema non parallelise", 1)
+      CALL adaptdt(iadv, dtbon, n, pbarug, massem)
+      IF(n > 1) WRITE(*, *) 'WARNING horizontal dt=', dtbon, 'dtvr=', dtvr, 'n=', n
+      DO indice = 1, n
+        CALL advn(q(1, 1, iq), massem, wg, pbarug, pbarvg, dtbon, 2)
+      END DO
+
+      !--------------------------------------------------------------------
+    CASE(20)  !--- Schema de pente SLOPES
+      !--------------------------------------------------------------------
+      CALL abort_gcm("advtrac", "schema SLOPES non parallelise", 1)
+      CALL pentes_ini (q(1, 1, iq), wg, massem, pbarug, pbarvg, 0)
+
+      !--------------------------------------------------------------------
+    CASE(30)  !--- Schema de Prather
+      !--------------------------------------------------------------------
+      CALL abort_gcm("advtrac", "schema prather non parallelise", 1)
+      ! Pas de temps adaptatif
+      CALL adaptdt(iadv, dtbon, n, pbarug, massem)
+      IF(n > 1) WRITE(*, *) 'WARNING horizontal dt=', dtbon, 'dtvr=', dtvr, 'n=', n
+      CALL prather(q(1, 1, iq), wg, massem, pbarug, pbarvg, n, dtbon)
+
+      !--------------------------------------------------------------------
+    CASE(11, 16, 17, 18)   !--- Schemas PPM Lin et Rood
+      !--------------------------------------------------------------------
+      CALL abort_gcm("advtrac", "schema PPM non parallelise", 1)
+      ! Test sur le flux horizontal
+      CALL adaptdt(iadv, dtbon, n, pbarug, massem)   ! pas de temps adaptatif
+      IF(n > 1) WRITE(*, *) 'WARNING horizontal dt=', dtbon, 'dtvr=', dtvr, 'n=', n
+      ! Test sur le flux vertical
+      CFLmaxz = 0.
+      DO l = 2, llm
+        DO ij = iip2, ip1jm
+          aaa = wg(ij, l) * dtvr / massem(ij, l)
+          CFLmaxz = max(CFLmaxz, aaa)
+          bbb = -wg(ij, l) * dtvr / massem(ij, l - 1)
+          CFLmaxz = max(CFLmaxz, bbb)
+        END DO
+      END DO
+      IF(CFLmaxz>=1) WRITE(*, *) 'WARNING vertical', 'CFLmaxz=', CFLmaxz
+      !----------------------------------------------------------------
+      !     Ss-prg interface LMDZ.4->PPM3d (ss-prg de Lin)
+      !----------------------------------------------------------------
+      CALL interpre(q(1, 1, iq), qppm(1, 1, iq), wg, fluxwppm, massem, &
+              apppm, bpppm, massebx, masseby, pbarug, pbarvg, &
+              unatppm, vnatppm, psppm)
+
+      !----------------------------------------------------------------
+      DO indice = 1, n     !--- VL (version PPM) horiz. et PPM vert.
+        !----------------------------------------------------------------
+        SELECT CASE(iadv)
+          !----------------------------------------------------------
+        CASE(11)
+          !----------------------------------------------------------
+          CALL ppm3d(1, qppm(1, 1, iq), psppm, psppm, unatppm, vnatppm, fluxwppm, dtbon, &
+                  2, 2, 2, 1, iim, jjp1, 2, llm, apppm, bpppm, 0.01, 6400000, fill, dum, 220.)
+          !----------------------------------------------------------
+        CASE(16) !--- Monotonic PPM
+          !----------------------------------------------------------
+          CALL ppm3d(1, qppm(1, 1, iq), psppm, psppm, unatppm, vnatppm, fluxwppm, dtbon, &
+                  3, 3, 3, 1, iim, jjp1, 2, llm, apppm, bpppm, 0.01, 6400000, fill, dum, 220.)
+          !----------------------------------------------------------
+        CASE(17) !--- Semi monotonic PPM
+          !----------------------------------------------------------
+          CALL ppm3d(1, qppm(1, 1, iq), psppm, psppm, unatppm, vnatppm, fluxwppm, dtbon, &
+                  4, 4, 4, 1, iim, jjp1, 2, llm, apppm, bpppm, 0.01, 6400000, fill, dum, 220.)
+          !----------------------------------------------------------
+        CASE(18) !--- Positive Definite PPM
+          !----------------------------------------------------------
+          CALL ppm3d(1, qppm(1, 1, iq), psppm, psppm, unatppm, vnatppm, fluxwppm, dtbon, &
+                  5, 5, 5, 1, iim, jjp1, 2, llm, apppm, bpppm, 0.01, 6400000, fill, dum, 220.)
+        END SELECT
+        !----------------------------------------------------------------
+      END DO
+      !----------------------------------------------------------------
+      !     Ss-prg interface PPM3d-LMDZ.4
+      !----------------------------------------------------------------
+      CALL interpost(q(1, 1, iq), qppm(1, 1, iq))
+      !----------------------------------------------------------------------
+    END SELECT
+    !----------------------------------------------------------------------
+
+    !----------------------------------------------------------------------
+    ! On impose une seule valeur du traceur au pole Sud j=jjm+1=jjp1 et Nord j=1
+    !----------------------------------------------------------------------
+    !  CALL traceurpole(q(1,1,iq),massem)
+
+    !--- Calcul du temps cpu pour un schema donne
+    !  CALL clock(t_final)
+    !ym  tps_cpu=t_final-t_initial
+    !ym  cpuadv(iq)=cpuadv(iq)+tps_cpu
+
+  END DO
+
+  1234 CONTINUE
+  !$OMP BARRIER
+  IF(planet_type=="earth") THEN
+    ijb = ij_begin
+    ije = ij_end
+    !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+    DO l = 1, llm
+      DO ij = ijb, ije
+        finmasse(ij, l) = p(ij, l) - p(ij, l + 1)
+      END DO
+    END DO
+    !$OMP END DO
+
+    CALL qminimum_loc(q, nqtot, finmasse)
+
+  END IF ! of if (planet_type=="earth")
+
+END SUBROUTINE advtrac_loc
+
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/bands.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/bands.F90	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/bands.F90	(revision 5101)
@@ -51,5 +51,5 @@
       integer :: ierr
     
-      call AllocateBands
+      CALL AllocateBands
       write(siim,'(i3)') iim
       write(sjjm,'(i3)') jjm
@@ -192,5 +192,5 @@
         
   
-      call allgather_timer_average
+      CALL allgather_timer_average
 
       do i=0,mpi_size-1
@@ -259,5 +259,5 @@
         
   
-      call allgather_timer_average
+      CALL allgather_timer_average
 
       do i=0,mpi_size-1
@@ -328,5 +328,5 @@
         
   
-      call allgather_timer_average
+      CALL allgather_timer_average
 
       do i=0,mpi_size-1
@@ -384,5 +384,5 @@
       ! Ehouarn: what follows is only related to // physics
       USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_PHYS
-      USE mod_phys_lmdz_para, only : klon_mpi_para_nb
+      USE mod_phys_lmdz_para, ONLY: klon_mpi_para_nb
 
       USE parallel_lmdz
@@ -399,5 +399,5 @@
         
   
-      call allgather_timer_average
+      CALL allgather_timer_average
       
       medium=0
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/bilan_dyn_loc.F
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/bilan_dyn_loc.F	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/bilan_dyn_loc.F	(revision 5101)
@@ -280,8 +280,8 @@
       dhe=(/ 0 /)
 
-      call flio_dom_set(mpi_size,mpi_rank,ddid,dsg,dsl,dpf,dpl,dhs,dhe, 
+      CALL flio_dom_set(mpi_size,mpi_rank,ddid,dsg,dsl,dpf,dpl,dhs,dhe,
      .                 'box',bilan_dyn_domain_id)
        
-      call histbeg(trim(infile),
+      CALL histbeg(trim(infile),
      .             1, rlong, jjn, rlatg(jjb:jje),
      .             1, 1, 1, jjn,
@@ -292,5 +292,5 @@
 C  Appel a histvert pour la grille verticale
 C
-      call histvert(fileid, 'presnivs', 'Niveaux sigma','mb',
+      CALL histvert(fileid, 'presnivs', 'Niveaux sigma','mb',
      .              llm, presnivs, zvertiid)
 C
@@ -317,5 +317,5 @@
      . WRITE(lunout,*)'var ',itr,iQ
      .      ,znom(itr,iQ),znoml(itr,iQ),zunites(itr,iQ)
-            call histdef(fileid,znom(itr,iQ),znoml(itr,iQ),
+            CALL histdef(fileid,znom(itr,iQ),znoml(itr,iQ),
      .        zunites(itr,iQ),1,jjn,thoriid,llm,1,llm,zvertiid,
      .        32,'ave(X)',dt_cum,dt_cum)
@@ -323,5 +323,5 @@
 c   Declarations pour les fonctions de courant
 c      print*,'2HISTDEF'
-          call histdef(fileid,'psi'//nom(iQ)
+          CALL histdef(fileid,'psi'//nom(iQ)
      .      ,'stream fn. '//znoml(itot,iQ),
      .      zunites(itot,iQ),1,jjn,thoriid,llm,1,llm,zvertiid,
@@ -332,13 +332,13 @@
 c   Declarations pour les champs de transport d'air
 c      print*,'3HISTDEF'
-      call histdef(fileid, 'masse', 'masse',
+      CALL histdef(fileid, 'masse', 'masse',
      .             'kg', 1, jjn, thoriid, llm, 1, llm, zvertiid,
      .             32, 'ave(X)', dt_cum, dt_cum)
-      call histdef(fileid, 'v', 'v',
+      CALL histdef(fileid, 'v', 'v',
      .             'm/s', 1, jjn, thoriid, llm, 1, llm, zvertiid,
      .             32, 'ave(X)', dt_cum, dt_cum)
 c   Declarations pour les fonctions de courant
 c      print*,'4HISTDEF'
-          call histdef(fileid,'psi','stream fn. MMC ','mega t/s',
+          CALL histdef(fileid,'psi','stream fn. MMC ','mega t/s',
      .      1,jjn,thoriid,llm,1,llm,zvertiid,
      .      32,'ave(X)',dt_cum,dt_cum)
@@ -349,5 +349,5 @@
       do iQ=1,nQ
          do itr=2,ntr
-            call histdef(fileid,'a'//znom(itr,iQ),znoml(itr,iQ),
+            CALL histdef(fileid,'a'//znom(itr,iQ),znoml(itr,iQ),
      .        zunites(itr,iQ),1,jjn,thoriid,1,1,1,-99,
      .        32,'ave(X)',dt_cum,dt_cum)
@@ -373,9 +373,9 @@
 !      ucont(:,jjb:jje,:)=0
 
-      call Register_Hallo_u(ucov,llm,1,1,1,1,Req)
-      call Register_Hallo_v(vcov,llm,1,1,1,1,Req)
-      call SendRequest(Req)
+      CALL Register_Hallo_u(ucov,llm,1,1,1,1,Req)
+      CALL Register_Hallo_v(vcov,llm,1,1,1,1,Req)
+      CALL SendRequest(Req)
 c$OMP BARRIER
-      call WaitRequest(Req)
+      CALL WaitRequest(Req)
 
       CALL covcont_loc(llm,ucov,vcov,ucont,vcont)
@@ -493,9 +493,9 @@
 c    -------------
       do iQ=1,nQ
-        call Register_Hallo_u(Q(1,jjb_u,1,iQ),llm,0,1,1,0,Req) 
-      enddo
-      call SendRequest(Req)
+        CALL Register_Hallo_u(Q(1,jjb_u,1,iQ),llm,0,1,1,0,Req)
+      enddo
+      CALL SendRequest(Req)
 !$OMP BARRIER      
-      call WaitRequest(Req)
+      CALL WaitRequest(Req)
       
       jjb=jj_begin
@@ -521,20 +521,20 @@
 
 c   convergence horizontale
-      call Register_Hallo_u(flux_uQ_cum,llm,2,2,2,2,Req)
-      call Register_Hallo_v(flux_vQ_cum,llm,2,2,2,2,Req)
-      call SendRequest(Req)
+      CALL Register_Hallo_u(flux_uQ_cum,llm,2,2,2,2,Req)
+      CALL Register_Hallo_v(flux_vQ_cum,llm,2,2,2,2,Req)
+      CALL SendRequest(Req)
 !$OMP BARRIER      
-      call WaitRequest(Req)
-
-      call  convflu_loc(flux_uQ_cum,flux_vQ_cum,llm*nQ,dQ)
+      CALL WaitRequest(Req)
+
+      CALL  convflu_loc(flux_uQ_cum,flux_vQ_cum,llm*nQ,dQ)
 
 c   calcul de la vitesse verticale
-      call Register_Hallo_u(flux_u_cum,llm,2,2,2,2,Req)
-      call Register_Hallo_v(flux_v_cum,llm,2,2,2,2,Req)
-      call SendRequest(Req)
+      CALL Register_Hallo_u(flux_u_cum,llm,2,2,2,2,Req)
+      CALL Register_Hallo_v(flux_v_cum,llm,2,2,2,2,Req)
+      CALL SendRequest(Req)
 !$OMP BARRIER      
-      call WaitRequest(Req)
-
-      call convmas_loc(flux_u_cum,flux_v_cum,convm)
+      CALL WaitRequest(Req)
+
+      CALL convmas_loc(flux_u_cum,flux_v_cum,convm)
       CALL vitvert_loc(convm,w)
 !$OMP BARRIER
@@ -659,14 +659,14 @@
 !$OMP BARRIER
 
-      call Register_Hallo_u(masse_cum,llm,1,1,1,1,Req)
-      do iQ=1,nQ
-        call Register_Hallo_u(Q_cum(1,jjb_u,1,iQ),llm,0,1,1,0,Req)
-      enddo
-
-      call SendRequest(Req)
-!$OMP BARRIER
-      call WaitRequest(Req)
-
-      call massbar_loc(masse_cum,massebx,masseby)
+      CALL Register_Hallo_u(masse_cum,llm,1,1,1,1,Req)
+      do iQ=1,nQ
+        CALL Register_Hallo_u(Q_cum(1,jjb_u,1,iQ),llm,0,1,1,0,Req)
+      enddo
+
+      CALL SendRequest(Req)
+!$OMP BARRIER
+      CALL WaitRequest(Req)
+
+      CALL massbar_loc(masse_cum,massebx,masseby)
       
       jjb=jj_begin
@@ -786,19 +786,19 @@
       do iQ=1,nQ
          do itr=1,ntr
-            call histwrite(fileid,znom(itr,iQ),itau,
+            CALL histwrite(fileid,znom(itr,iQ),itau,
      s                     zvQ(jjb:jje,:,itr,iQ)
      s                     ,jjn*llm,ndex3d)
          enddo
-         call histwrite(fileid,'psi'//nom(iQ),
+         CALL histwrite(fileid,'psi'//nom(iQ),
      s                  itau,psiQ(jjb:jje,1:llm,iQ)
      s                  ,jjn*llm,ndex3d)
       enddo
 
-      call histwrite(fileid,'masse',itau,zmasse(jjb:jje,1:llm)
+      CALL histwrite(fileid,'masse',itau,zmasse(jjb:jje,1:llm)
      s   ,jjn*llm,ndex3d)
-      call histwrite(fileid,'v',itau,zv(jjb:jje,1:llm)
+      CALL histwrite(fileid,'v',itau,zv(jjb:jje,1:llm)
      s   ,jjn*llm,ndex3d)
       psi(jjb:jje,:)=psi(jjb:jje,:)*1.e-9
-      call histwrite(fileid,'psi',itau,psi(jjb:jje,1:llm),
+      CALL histwrite(fileid,'psi',itau,psi(jjb:jje,1:llm),
      s               jjn*llm,ndex3d)
 
@@ -824,5 +824,5 @@
             enddo
             zavQ(jjb:jje,itr,iQ)=zavQ(jjb:jje,itr,iQ)/zamasse(jjb:jje)
-            call histwrite(fileid,'a'//znom(itr,iQ),itau,
+            CALL histwrite(fileid,'a'//znom(itr,iQ),itau,
      s                     zavQ(jjb:jje,itr,iQ),jjn*llm,ndex3d)
          enddo
@@ -838,5 +838,5 @@
 c=====================================================================
 !$OMP MASTER
-      call histsync(fileid)
+      CALL histsync(fileid)
 !$OMP END MASTER
 
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/caladvtrac_loc.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/caladvtrac_loc.f90	(revision 5101)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/caladvtrac_loc.f90	(revision 5101)
@@ -0,0 +1,215 @@
+! $Id: caladvtrac_p.F 1299 2010-01-20 14:27:21Z fairhead $
+
+!
+!
+SUBROUTINE caladvtrac_loc(q, pbaru, pbarv, &
+        p, masse, dq, teta, &
+        flxw, pk, iapptrac)
+  USE parallel_lmdz
+  USE infotrac, ONLY: nqtot
+  USE control_mod, ONLY: iapp_tracvl, planet_type
+  USE caladvtrac_mod
+  USE mod_hallo
+  USE bands
+  USE times
+  USE Vampir
+  USE write_field_loc
+  USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_DEBUGIO
+
+  IMPLICIT NONE
+  !
+  ! Auteurs:   F.Hourdin , P.Le Van, F.Forget, F.Codron
+  !
+  ! F.Codron (10/99) : ajout humidite specifique pour eau vapeur
+  !=======================================================================
+  !
+  !   Shema de  Van Leer
+  !
+  !=======================================================================
+
+  include "dimensions.h"
+  include "paramet.h"
+
+  !   Arguments:
+  !   ----------
+  REAL :: pbaru(ijb_u:ije_u, llm), pbarv(ijb_v:ije_v, llm)
+  REAL :: masse(ijb_u:ije_u, llm)
+  REAL :: p(ijb_u:ije_u, llmp1)
+  REAL :: q(ijb_u:ije_u, llm, nqtot), dq(ijb_u:ije_u, llm, nqtot)
+  REAL :: teta(ijb_u:ije_u, llm), pk(ijb_u:ije_u, llm)
+  REAL :: flxw(ijb_u:ije_u, llm)
+  INTEGER :: iapptrac
+  !   Local:
+  !   ------
+  ! REAL :: pbarug(ijb_u:ije_u,llm)
+  ! REAL :: pbarvg(ijb_v:ije_v,llm)
+  !      REAL :: wg(ijb_u:ije_u,llm)
+
+  REAL :: flxw_adv(distrib_vanleer%ijb_u:distrib_vanleer%ije_u, llm)
+  INTEGER, SAVE :: iadvtr = 0
+  !$OMP THREADPRIVATE(iadvtr)
+  INTEGER :: ijb, ije, ijbu, ijbv, ijeu, ijev, j
+  INTEGER :: ij, l
+  TYPE(Request), SAVE :: Request_vanleer
+  !$OMP THREADPRIVATE(Request_vanleer)
+
+  ! !write(*,*) 'caladvtrac 58: entree'
+  ijbu = ij_begin
+  ijeu = ij_end
+
+  ijbv = ij_begin - iip1
+  ijev = ij_end
+  if (pole_nord) ijbv = ij_begin
+  if (pole_sud)  ijev = ij_end - iip1
+
+  IF(iadvtr==0) THEN
+    !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+    DO l = 1, llm
+      pbaruc(ijbu:ijeu, l) = 0.
+      pbarvc(ijbv:ijev, l) = 0.
+    ENDDO
+    !$OMP END DO NOWAIT
+  ENDIF
+
+  !   accumulation des flux de masse horizontaux
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l = 1, llm
+    DO ij = ijbu, ijeu
+      pbaruc(ij, l) = pbaruc(ij, l) + pbaru(ij, l)
+    ENDDO
+    DO ij = ijbv, ijev
+      pbarvc(ij, l) = pbarvc(ij, l) + pbarv(ij, l)
+    ENDDO
+  ENDDO
+  !$OMP END DO NOWAIT
+
+  !   selection de la masse instantannee des mailles avant le transport.
+  IF(iadvtr==0) THEN
+
+    ijb = ij_begin
+    ije = ij_end
+
+    !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+    DO l = 1, llm
+      massem(ijb:ije, l) = masse(ijb:ije, l)
+    ENDDO
+    !$OMP END DO NOWAIT
+
+  ENDIF
+
+  iadvtr = iadvtr + 1
+
+  !$OMP MASTER
+  iapptrac = iadvtr
+  !$OMP END MASTER
+
+  !   Test pour savoir si on advecte a ce pas de temps
+
+  IF (iadvtr==iapp_tracvl) THEN
+    ! !write(*,*) 'caladvtrac 133'
+    !$OMP MASTER
+    CALL suspend_timer(timer_caldyn)
+    !$OMP END MASTER
+
+    ijb = ij_begin
+    ije = ij_end
+
+    !c   ..  Modif P.Le Van  ( 20/12/97 )  ....
+    !c
+
+    !   traitement des flux de masse avant advection.
+    ! 1. calcul de w
+    ! 2. groupement des mailles pres du pole.
+
+    CALL groupe_loc(massem, pbaruc, pbarvc, pbarug, pbarvg, wg)
+
+    !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+    DO l = 1, llm
+      flxw(ijb:ije, l) = wg(ijb:ije, l) / REAL(iapp_tracvl)
+    ENDDO
+    !$OMP ENDDO NOWAIT
+
+    IF (CPPKEY_DEBUGIO) THEN
+      CALL WriteField_u('pbarug1', pbarug)
+      CALL WriteField_v('pbarvg1', pbarvg)
+      CALL WriteField_u('wg1', wg)
+    END IF
+
+    !$OMP BARRIER
+
+
+    !$OMP MASTER
+    CALL VTb(VTHallo)
+    !$OMP END MASTER
+
+    CALL Register_SwapField_u(pbarug, pbarug_adv, distrib_vanleer, &
+            Request_vanleer)
+    CALL Register_SwapField_v(pbarvg, pbarvg_adv, distrib_vanleer, &
+            Request_vanleer, up = 1)
+    CALL Register_SwapField_u(massem, massem_adv, distrib_vanleer, &
+            Request_vanleer)
+    CALL Register_SwapField_u(wg, wg_adv, distrib_vanleer, &
+            Request_vanleer)
+    CALL Register_SwapField_u(teta, teta_adv, distrib_vanleer, &
+            Request_vanleer, up = 1, down = 1)
+    CALL Register_SwapField_u(p, p_adv, distrib_vanleer, &
+            Request_vanleer, up = 1, down = 1)
+    CALL Register_SwapField_u(pk, pk_adv, distrib_vanleer, &
+            Request_vanleer, up = 1, down = 1)
+    CALL Register_SwapField_u(q, q_adv, distrib_vanleer, &
+            Request_vanleer)
+
+    CALL SendRequest(Request_vanleer)
+    !$OMP BARRIER
+    CALL WaitRequest(Request_vanleer)
+
+
+    !$OMP BARRIER
+    !$OMP MASTER
+    CALL Set_Distrib(distrib_vanleer)
+    CALL VTe(VTHallo)
+    CALL VTb(VTadvection)
+    CALL start_timer(timer_vanleer)
+    !$OMP END MASTER
+    !$OMP BARRIER
+    ! CALL WriteField_u('pbarug_adv',pbarug_adv)
+    ! CALL WriteField_u('',)
+
+    IF (CPPKEY_DEBUGIO) THEN
+      CALL WriteField_u('pbarug1', pbarug_adv)
+      CALL WriteField_v('pbarvg1', pbarvg_adv)
+      CALL WriteField_u('wg1', wg_adv)
+    END IF
+    ! !write(*,*) 'caladvtrac 185'
+    CALL advtrac_loc(pbarug_adv, pbarvg_adv, wg_adv, &
+            p_adv, massem_adv, q_adv, teta_adv, &
+            pk_adv)
+    ! !write(*,*) 'caladvtrac 189'
+
+
+    !$OMP MASTER
+    CALL VTe(VTadvection)
+    CALL stop_timer(timer_vanleer)
+    CALL VTb(VThallo)
+    !$OMP END MASTER
+
+    CALL Register_SwapField_u(q_adv, q, distrib_caldyn, &
+            Request_vanleer)
+
+    CALL SendRequest(Request_vanleer)
+    !$OMP BARRIER
+    CALL WaitRequest(Request_vanleer)
+
+    !$OMP BARRIER
+    !$OMP MASTER
+    CALL Set_Distrib(distrib_caldyn)
+    CALL VTe(VThallo)
+    CALL resume_timer(timer_caldyn)
+    !$OMP END MASTER
+    !$OMP BARRIER
+    iadvtr = 0
+  ENDIF ! if iadvtr.EQ.iapp_tracvl
+
+END SUBROUTINE caladvtrac_loc
+
+
